## minetest 0.4.12+repack

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
if(${CMAKE_VERSION} STREQUAL "2.8.2")
  # bug http://vtk.org/Bug/view.php?id=11020
  message( WARNING "CMake/CPack version 2.8.2 will not create working .deb packages!")
endif(${CMAKE_VERSION} STREQUAL "2.8.2")

# This can be read from ${PROJECT_NAME} after project() is called
project(minetest)

set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")

# Also remember to set PROTOCOL_VERSION in clientserver.h when releasing
set(VERSION_MAJOR 0)
set(VERSION_MINOR 4)
set(VERSION_PATCH 12)
set(VERSION_PATCH_ORIG ${VERSION_PATCH})

if(VERSION_EXTRA)
	set(VERSION_PATCH ${VERSION_PATCH}-${VERSION_EXTRA})
else()
	# Comment the following line during release
	#set(VERSION_PATCH ${VERSION_PATCH}-dev)
endif()
set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

MESSAGE(STATUS "*** Will build version ${VERSION_STRING} ***")

# Configuration options

if(WIN32)
	set(RUN_IN_PLACE 1 CACHE BOOL "Run directly in source directory structure")
else()
	set(RUN_IN_PLACE 0 CACHE BOOL "Run directly in source directory structure")
endif()

# RUN_IN_PLACE is exported as a #define value, ensure it's 1/0 instead of ON/OFF
if(RUN_IN_PLACE)
	set(RUN_IN_PLACE 1)
else()
	set(RUN_IN_PLACE 0)
endif()

set(BUILD_CLIENT 1 CACHE BOOL "Build client")
if(WIN32)
	set(BUILD_SERVER 0 CACHE BOOL "Build server")
else()
	set(BUILD_SERVER 1 CACHE BOOL "Build server")
endif()

set(WARN_ALL 1 CACHE BOOL "Enable -Wall for Release build")

if(NOT CMAKE_BUILD_TYPE)
	# Default to release
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type: Debug or Release" FORCE)
endif()

# Included stuff
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
include(${CMAKE_SOURCE_DIR}/cmake/Modules/misc.cmake)

# This is done here so that relative search paths are more reasnable
find_package(Irrlicht)

#
# Installation
#

if(WIN32)
	set(SHAREDIR ".")
	set(BINDIR "bin")
	set(DOCDIR "doc")
	set(EXAMPLE_CONF_DIR ".")
	set(LOCALEDIR "locale")
elseif(APPLE)
	set(SHAREDIR ".")
	set(BINDIR ".")
	set(DOCDIR "./doc/${PROJECT_NAME}")
	set(EXAMPLE_CONF_DIR ${DOCDIR})
	set(LOCALEDIR "locale")
elseif(UNIX) # Linux, BSD etc
	if(RUN_IN_PLACE)
		set(SHAREDIR ".")
		set(BINDIR "bin")
		set(DOCDIR "doc")
		set(EXAMPLE_CONF_DIR ".")
		set(MANDIR "unix/man")
		set(XDG_APPS_DIR "unix/applications")
		set(APPDATADIR "unix/appdata")
		set(ICONDIR "unix/icons")
		set(LOCALEDIR "locale")
	else()
		set(SHAREDIR "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}")
		set(BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
		set(DOCDIR "${CMAKE_INSTALL_PREFIX}/share/doc/${PROJECT_NAME}")
		set(MANDIR "${CMAKE_INSTALL_PREFIX}/share/man")
		set(EXAMPLE_CONF_DIR ${DOCDIR})
		set(XDG_APPS_DIR "${CMAKE_INSTALL_PREFIX}/share/applications")
		set(APPDATADIR "${CMAKE_INSTALL_PREFIX}/share/appdata")
		set(ICONDIR "${CMAKE_INSTALL_PREFIX}/share/icons")
		set(LOCALEDIR "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/locale")
	endif()
endif()

set(CUSTOM_SHAREDIR "" CACHE STRING "Directory to install data files into")
if(NOT CUSTOM_SHAREDIR STREQUAL "")
	set(SHAREDIR "${CUSTOM_SHAREDIR}")
	message(STATUS "Using SHAREDIR=${SHAREDIR}")
endif()
set(CUSTOM_BINDIR "" CACHE STRING "Directory to install binaries into")
if(NOT CUSTOM_BINDIR STREQUAL "")
	set(BINDIR "${CUSTOM_BINDIR}")
	message(STATUS "Using BINDIR=${BINDIR}")
endif()
set(CUSTOM_DOCDIR "" CACHE STRING "Directory to install documentation into")
if(NOT CUSTOM_DOCDIR STREQUAL "")
	set(DOCDIR "${CUSTOM_DOCDIR}")
	message(STATUS "Using DOCDIR=${DOCDIR}")
endif()
set(CUSTOM_MANDIR "" CACHE STRING "Directory to install manpages into")
if(NOT CUSTOM_MANDIR STREQUAL "")
	set(MANDIR "${CUSTOM_MANDIR}")
	message(STATUS "Using MANDIR=${MANDIR}")
endif()
set(CUSTOM_EXAMPLE_CONF_DIR "" CACHE STRING "Directory to install example config file into")
if(NOT CUSTOM_EXAMPLE_CONF_DIR STREQUAL "")
	set(EXAMPLE_CONF_DIR "${CUSTOM_EXAMPLE_CONF_DIR}")
	message(STATUS "Using EXAMPLE_CONF_DIR=${EXAMPLE_CONF_DIR}")
endif()
set(CUSTOM_XDG_APPS_DIR "" CACHE STRING "Directory to install .desktop files into")
if(NOT CUSTOM_XDG_APPS_DIR STREQUAL "")
	set(XDG_APPS_DIR "${CUSTOM_XDG_APPS_DIR}")
	message(STATUS "Using XDG_APPS_DIR=${XDG_APPS_DIR}")
endif()
set(CUSTOM_ICONDIR "" CACHE STRING "Directory to install icons into")
if(NOT CUSTOM_ICONDIR STREQUAL "")
	set(ICONDIR "${CUSTOM_ICONDIR}")
	message(STATUS "Using ICONDIR=${ICONDIR}")
endif()
set(CUSTOM_LOCALEDIR "" CACHE STRING "Directory to install l10n files into")
if(NOT CUSTOM_LOCALEDIR STREQUAL "")
	set(LOCALEDIR "${CUSTOM_LOCALEDIR}")
	message(STATUS "Using LOCALEDIR=${LOCALEDIR}")
endif()

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/builtin" DESTINATION "${SHAREDIR}")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/client" DESTINATION "${SHAREDIR}")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/games/minimal" DESTINATION "${SHAREDIR}/games")
set(MINETEST_GAME_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/games/minetest_game")
if(EXISTS ${MINETEST_GAME_SOURCE} AND IS_DIRECTORY ${MINETEST_GAME_SOURCE})
	install(FILES ${MINETEST_GAME_SOURCE}/game.conf DESTINATION "${SHAREDIR}/games/minetest_game/")
	install(FILES ${MINETEST_GAME_SOURCE}/README.txt DESTINATION "${SHAREDIR}/games/minetest_game/")
	install(DIRECTORY ${MINETEST_GAME_SOURCE}/mods DESTINATION "${SHAREDIR}/games/minetest_game")
	install(DIRECTORY ${MINETEST_GAME_SOURCE}/menu DESTINATION "${SHAREDIR}/games/minetest_game")
endif()
if(BUILD_CLIENT)
	#install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/sounds/base/pack" DESTINATION "${SHAREDIR}/sounds/base")
	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/textures/base/pack" DESTINATION "${SHAREDIR}/textures/base")
endif()
if(RUN_IN_PLACE)
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/mods/mods_here.txt" DESTINATION "${SHAREDIR}/mods")
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/textures/texture_packs_here.txt" DESTINATION "${SHAREDIR}/textures")
endif()

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/fonts" DESTINATION "${SHAREDIR}")

install(FILES "README.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/lua_api.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/menu_lua_api.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/mapformat.txt" DESTINATION "${DOCDIR}")
install(FILES "minetest.conf.example" DESTINATION "${EXAMPLE_CONF_DIR}")

if(UNIX AND NOT APPLE)
	install(FILES "doc/minetest.6" "doc/minetestserver.6" DESTINATION "${MANDIR}/man6")
	install(FILES "misc/minetest.desktop" DESTINATION "${XDG_APPS_DIR}")
	install(FILES "misc/minetest.appdata.xml" DESTINATION "${APPDATADIR}")
	install(FILES "misc/minetest-icon.svg" DESTINATION "${ICONDIR}/hicolor/scalable/apps")
endif()

#
# Subdirectories
# Be sure to add all relevant definitions above this
#

add_subdirectory(src)

# CPack

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An InfiniMiner/Minecraft inspired game")
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_PACKAGE_VENDOR "celeron55")
set(CPACK_PACKAGE_CONTACT "Perttu Ahola <celeron55@gmail.com>")

if(WIN32)
	# For some reason these aren't copied otherwise
	# NOTE: For some reason now it seems to work without these
	#if(BUILD_CLIENT)
	#	install(FILES bin/minetest.exe DESTINATION bin)
	#endif()
	#if(BUILD_SERVER)
	#	install(FILES bin/minetestserver.exe DESTINATION bin)
	#endif()

	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-win64")
	else(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-win32")
	endif(CMAKE_SIZEOF_VOID_P EQUAL 8)

	set(CPACK_GENERATOR ZIP)

	# This might be needed for some installer
	#set(CPACK_PACKAGE_EXECUTABLES bin/minetest.exe "Minetest" bin/minetestserver.exe "Minetest Server")
elseif(APPLE)
	set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-osx")
	set(CPACK_PACKAGE_ICON ${CMAKE_CURRENT_SOURCE_DIR}/misc/minetest-icon.icns)
	set(CPACK_BUNDLE_NAME ${PROJECT_NAME})
	set(CPACK_BUNDLE_ICON ${CPACK_PACKAGE_ICON})
	set(CPACK_BUNDLE_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/misc/Info.plist)
	set(CPACK_GENERATOR "Bundle")
else()
	set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-linux")
	set(CPACK_GENERATOR TGZ)
	set(CPACK_SOURCE_GENERATOR TGZ)
endif()

include(CPack)

# Add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
		COMMENT "Generating API documentation with Doxygen" VERBATIM
	)
endif(DOXYGEN_FOUND)

=== debian/changelog ===
minetest (0.4.12+repack-2build1) wily; urgency=medium

  * No-change rebuild against libjsoncpp0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 00:50:01 +0000

minetest (0.4.12+repack-2) unstable; urgency=medium

  * Fix FTBFS on architectures where luajit is not available.
    Update rawlua.patch. Do not add embedded lua subdirectory
    to build because it was removed.

 -- Markus Koschany <apo@gambaru.de>  Tue, 17 Mar 2015 18:15:33 +0100

minetest (0.4.12+repack-1) experimental; urgency=medium

  * Imported Upstream version 0.4.12+repack. (Closes: #778853)
  * Drop the following patches. They were merged upstream.
    - desktop-file.patch
    - hurd.patch
    - hyphen-used-as-minus.patch
  * Drop desktop-file-fix-icon.patch. Instead rename minetest icons and use
    the upstream name again. Install minetest.xpm to /usr/share/pixmaps which
    is a better location for xpm files.
  * Use dh_installchangelogs override for installing the upstream changelog.
  * Drop useless-depends.patch. Add missing build-dependencies instead.
  * Add libbz2-dev, libglu1-mesa-dev, libpng-dev and libjpeg-dev to
    Build-Depends.
  * wrap-and-sort -sa.
  * Drop gcc47.patch because it is obsolete.
  * Create directory for minetest.xpm in debian/rules and improve formatting.
  * Remove dh_auto_build override. Use --parallel with main dh invocation.
  * Use dh_auto_configure command to pass on build flags. Do not call cmake
    manually.
  * Rename debianization.patch to FindIrrlicht.cmake.patch. Append
    libIrrlicht.so to search patch instead of replacing other alternatives.
  * Drop dynamic-link.patch. Add FindJson.cmake.patch instead.
    - Remove unnecessary hunks and patch only FindJson.cmake module. This
      ensures that Debian's system json library will be used and simplifies
      future updates.

 -- Markus Koschany <apo@gambaru.de>  Mon, 16 Mar 2015 18:47:04 +0100

=== debian/control ===
Source: minetest
Section: games
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Michael Gilbert <mgilbert@debian.org>,
 Martin Quinson <mquinson@debian.org>,
 Markus Koschany <apo@gambaru.de>
Build-Depends:
 cmake,
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 gettext,
 imagemagick,
 libbz2-dev,
 libcurl4-gnutls-dev,
 libfreetype6-dev,
 libglu1-mesa-dev,
 libirrlicht-dev (>= 1.7.0),
 libjpeg-dev,
 libjsoncpp-dev,
 libleveldb-dev,
 libluajit-5.1-dev [i386 amd64 kfreebsd-i386 armel armhf powerpc powerpcspe mips] | liblua5.1-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsqlite3-dev,
 libvorbis-dev,
 libx11-dev,
 zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://minetest.net/
Vcs-Git: git://anonscm.debian.org/pkg-games/minetest-v04x.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/minetest-v04x.git

Package: minetest
Architecture: any
Depends:
 minetest-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 minetestc55
Suggests:
 minetest-mod-moreblocks,
 minetest-mod-moreores,
 minetest-mod-pipeworks,
 minetest-server
Description: Multiplayer infinite-world block sandbox
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.

Package: minetest-dbg
Architecture: any
Section: debug
Depends:
 minetest (= ${binary:Version}) | minetest-server (= ${binary:Version}),
 ${misc:Depends}
Description: Multiplayer infinite-world block sandbox (debugging symbols)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the debugging symbols in case something goes wrong.

Package: minetest-server
Architecture: any
Depends:
 adduser,
 minetest-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Multiplayer infinite-world block sandbox (server)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the minetest server package.

Package: minetest-data
Architecture: all
Depends:
 fonts-liberation,
 python,
 python-imaging,
 ${misc:Depends}
Breaks:
 minetest (<< 0.3.1+dfsg-3),
 minetest-common
Conflicts:
 minetest-common
Replaces:
 minetest-common
Description: Multiplayer infinite-world block sandbox (data files)
 Minetest is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.

=== debian/rules ===
#!/usr/bin/make -f

# avoid useless dependencies
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# upstream version
version=$(shell uscan --report-status | head -2 | tail -1 | cut -d' ' -f7 | cut -d, -f1)
tmpdir:=$(shell mktemp -d)
wrkdir:=$(shell pwd)

# build-hardening flags
export DEB_BUILD_MAINT_OPTIONS="hardening=+all"

# file names
sources=$(shell find . -name *.cpp)
headers=$(shell find . -name *.h)
dfsgremovals=Makefile.bak \
	     .gitattributes \
	     .hg_archival \
	     .hg_archival.txt \
	     .hgignore \
	     .hgtags \
	     fontlucida.png \
	     sqlite \
	     json \
	     lua
#	     jthread # upstream patched that lib, which seem dead upstream itself, so use minetest's version even if I don't like it.
cleanremovals= bin \
	       CMakeFiles \
	       src/CMakeFiles \
	       CMakeCache.txt \
	       CPackConfig.cmake \
	       CPackSourceConfig.cmake \
	       Makefile \
	       cmake_install.cmake \
	       src/Makefile \
	       src/cmake_config.h \
	       src/cmake_install.cmake \
	       locale \
	       install_manifest.txt \
	       minetest.xpm \
	       minetest.svg \
	       minetest.png \
	       src/cguittfont/CMakeFiles/ \
	       src/cguittfont/Makefile \
	       src/cguittfont/cmake_install.cmake \
	       src/cguittfont/libcguittfont.a

override_dh_clean:
	dh_clean --exclude old/Makefile.old

override_dh_auto_clean:
	dh_clean --exclude old/Makefile.old
	rm -rf ${cleanremovals}

override_dh_auto_configure:
	dh_auto_configure -- \
		-DRUN_IN_PLACE=0 \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DENABLE_GETTEXT=1 \
		-DENABLE_FREETYPE=1 \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2 \
		-DFREETYPE_INCLUDE_DIR_ft2build=/usr/include \
		-DENABLE_LEVELDB=1 \
		-DLEVELDB_INCLUDE_DIR=/usr/include/leveldb \
		-DCUSTOM_LOCALEDIR=/usr/share/locale \
		-DCUSTOM_SHAREDIR=/usr/share/games/minetest \
		-DCMAKE_INSTALL_PREFIX=/usr

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_install:
	dh_install --list-missing -X.gitignore
	# copy the logo
	mkdir -p \
		debian/minetest/usr/share/icons/hicolor/24x24/apps/ \
		debian/minetest/usr/share/pixmaps/
	cp \
		misc/minetest-icon-24x24.png \
		debian/minetest/usr/share/icons/hicolor/24x24/apps/minetest-icon.png
	convert \
		debian/minetest/usr/share/icons/hicolor/24x24/apps/minetest-icon.png \
		debian/minetest/usr/share/pixmaps/minetest.xpm
	mkdir -p debian/minetest/usr/share/icons/hicolor/scalable/apps/
	cp misc/minetest-icon.svg debian/minetest/usr/share/icons/hicolor/scalable/apps/
	# take care of the fonts we need
	mkdir -p debian/minetest-data/usr/share/games/minetest/fonts/
	ln -s /usr/share/fonts/truetype/liberation/LiberationMono-Regular.ttf \
	      debian/minetest-data/usr/share/games/minetest/fonts/liberationmono.ttf
	ln -s /usr/share/fonts/truetype/liberation/LiberationSans-Regular.ttf \
	      debian/minetest-data/usr/share/games/minetest/fonts/liberationsans.ttf
	# Install the mapper script
	mkdir -p debian/minetest-data/usr/games
	cp util/minetestmapper.py debian/minetest-data/usr/games/minetest-mapper
	cp util/colors.txt        debian/minetest-data/usr/share/games/minetest/minetestmapper-colors.txt

override_dh_strip:
	dh_strip --dbg-package=minetest-dbg

get-orig-source:
	rm -f ${wrkdir}/../minetest_${version}+repack.orig.tar.gz
	uscan --verbose --force-download && mv ../${version}.tar.gz ${tmpdir} || true
	set +ex; cd ${tmpdir} && \
	    tar xf ${version}.tar.gz && rm -f ${version}.tar.gz && \
	    cd minetest-${version}/games && \
	    for game in minetest_game ; do \
	       wget --no-verbose https://github.com/minetest/$${game}/archive/${version}.tar.gz -O - | tar xfz - ; \
	       mv $${game}-${version} $${game} ; \
	       done && \
	    cd .. ; \
	    for file in ${dfsgremovals}; do \
	        find . -name $$file -execdir rm -rf {} \; 2>/dev/null || true; \
		done && \
	    tar cf ${wrkdir}/../minetest_${version}+repack.orig.tar * ; \
	    gzip --best ${wrkdir}/../minetest_${version}+repack.orig.tar
	rm -rf ${tmpdir}
	@echo "successfully created new tarball: ${wrkdir}/../minetest_${version}+repack.orig.tar.gz"

%:
	dh ${@} --parallel --with systemd
